#!/bin/bash
# Set this if you are using a remote server or another protocol
export DISPLAY=:0.0			
export LANG=de_DE

if [ "$1" != "-w" ] ; then
#   xinfo=$(xrandr -d :0 -q |grep current)
#   WIDTH=${xinfo#*current }
#   WIDTH=${WIDTH%% *}
#   HEIGHT=${xinfo#*current }
#   HEIGHT=${HEIGHT%%,*}
#   HEIGHT=${HEIGHT##* }
#   GEOMETRY="--geometry ${WIDTH}x${HEIGHT}"
   GEOMETRY="--fullscreen"
else   
   GEOMETRY=""
fi

# Only used if set to manuell
AO="alsa"
#AO="none"
VO="xshm"
#XINE_CROP="--post autocrop:enable_autodetect=0,enable_subs_detect=1,soft_start=0,stabilize=1"

logger "$0 starting ..."
LOG_FILE="/tmp/vdr-xine.log"
while [ "$(pidof vdr)" != "" -a ! -e /tmp/.stopxvdr -a ! -e /tmp/.shutdown -a ! -e /tmp/.vdrdisabled ]; do
#   [ "$AO_DRIVER" != "manuell" ] && AO="$AO_DRIVER"   
   source /etc/vdr.d/conf/vdr

   PARMS="$GEOMETRY"
   if [ "$VO_DRIVER" = "x11" ] ; then
      VO="xshm"
   elif [ "$VO_DRIVER" = "vdpau" ] ; then
      VO="$VO_DRIVER"
      PARMS="$PARMS --post tvtime:method=use_vo_driver"
   elif [ "$VO_DRIVER" != "manuell" ] ; then
      VO="$VO_DRIVER"
   fi      
   killall -9 vdr-sxfe oxine xine > /dev/null 2>&1

   if [ "${PLUGINS%xineliboutput*}" != "$PLUGINS" ] ; then
      CMD_EXE="vdr-sxfe"
      CMD_INPUT="xvdr://localhost"
      if [ "$(grep VideoFormat /etc/vdr/setup.conf| grep 1)"  != "" ] ; then
         ASPECT="--aspect=16:9"
      else      
         ASPECT="--aspect=4:3"
      fi
      PARMS="$PARMS --config=/root/.xine/config_xineliboutput --video=$VO --audio=$AO --reconnect $ASPECT"
   else
      CMD_EXE="xine"
      CMD_INPUT="vdr:/tmp/vdr-xine/stream#demux:mpeg_pes"
      if [ "$(grep VideoFormat /etc/vdr/setup.conf| grep 1)"  != "" ] ; then
         ASPECT="-r auto"
      else      
         ASPECT="-r 4:3"
      fi	 
      PARMS="$PARMS --keymap=file:/root/.xine/keymap $XINE_CROP --hide-gui --no-lirc --no-splash --no-gui --verbose -V $VO $ASPECT"
   fi	 
   logger -s "$0 - starte <$CMD_EXE $PARMS $CMD_INPUT>"   
   $CMD_EXE $PARMS "$CMD_INPUT" 2>&1 |tee -a $LOG_FILE
   rc=${PIPESTATUS[0]}
   tail -n 5 $LOG_FILE | logger -s
   echo "" >> $LOG_FILE
   if [ "$rc" = "0" ] ; then
      logger "xine gui ended"
      [ "$GUI" != "VDR" ] && touch /tmp/.stopxvdr
   else	 	 
      logger "xine gui died ($rc)"
   fi
   cp $LOG_FILE $LOG_FILE.old
   sleep 1      
done      
logger "$0 - exiting"   
